MAX_IL	equ 15
OP_ESC2B	equ 0FH
MODRM_MOD		equ 11000000B
MODRM_REG		equ 00111000B
MODRM_RM		equ 00000111B

SIB_SCALE		equ 11000000B
SIB_INDEX		equ 00111000B
SIB_BASE		equ 00000111B

JCC_BASE_SHORT	equ 70H
JCC_BASE_NEAR	equ 80H

align 4	
DiOpLineI: ; FEDCBA9876533210
		DW 0000000000000000B	; 7	; JCC
		DW 1111111111111111B	; 8
		DW 1111101111111111B	; 9	; CALLF
		DW 1111111111111111B	; A
		DW 1111111111111111B	; B
		DW 0101001111110011B	; C	; RETF, IRETD, INT
		DW 1111111111111111B	; D
		DW 1111000011110000B	; E	; LOOPX, CALL, JMP
		DW 1111111111111111B	; F
; +
;
DiIsLine proc pOpcode:PVOID
	mov ecx,pOpcode
	movzx eax,B[ecx]
	.if Al == 0FH	; Esc 2.
		movzx eax,B[ecx][1]
		cmp al,34H	; sysenter
		je Exit
		cmp al,35H	; sysexit
		je Exit
		cmp al,80H	; Jcc
		jb Exit
		cmp al,90H
		cmc
		jmp Exit
	.endif
	
	.if Al == 0FFH	; Grp5
		movzx eax,B[ecx][1]
		and al,MODRM_REG
		cmp al,2 shl 3
		jb Exit
		cmp al,6 shl 3
		cmc
		jmp Exit
	.endif
	
	sub al,70H
	.if !Carry?
		bt D[DiOpLineI],eax
	.endif
Exit:
	ret
DiIsLine endp

; +
;
DiQueryPrefixes proc uses esi edi Ip:PVOID
Local Table[12]:BYTE, xMask:ULONG
	mov edx,MAX_IL
	mov xMask,0
	mov D[Table][0],67F0F2F3H
	mov D[Table][4],26646566H
	mov D[Table][8],002E3E36H
	mov esi,Ip
	cld
@@:
	lodsb
	lea edi,Table
	mov ecx,11
	repne scasb
	.if Zero?
		bts xMask,ecx
		dec edx
		jnz @b
	.endif
	not edx
	mov ecx,xMask
	lea eax,[edx + MAX_IL + 1]
	ret
DiQueryPrefixes endp

	include Dizahex.inc
	includelib dizahex.lib

.data
Run		BYTE (MAX_IL + 1)*64 DUP (?)
Rdisp	ULONG ?
Map		ULONG 64 DUP (?)
Mi		ULONG ?

Diss		DIZAHEX <>
DiPfx	ULONG ?

Tcm		PVOID ?
TcmN		ULONG ?
TcmIp	PVOID ?
TcmD		PVOID 64 DUP (?)

.code
TcmAdd proc Ip:PVOID
	mov ecx,TcmN
	lea eax,[ecx*8]
	add eax,Tcm
	
	push Ip
	pop TcmD[ecx*4]
	inc TcmN
	ret
TcmAdd endp

; +
; [Esp]: CM-ip
;
TcmGet proc C
	int 3
	xchg D[esp],eax
	pushfd
	sub eax,Tcm
	sub eax,5
	shr eax,1
	mov eax,TcmD[eax]
	mov TcmIp,eax
	and TcmN,0
	or D[esp],EFLAGS_TF
	popfd
	pop eax
	jmp TcmIp
TcmGet endp


CyIsolate proc uses ebx esi edi
Local Ip:PVOID
	lea edi,Run
	mov ebx,Ta
Walk:
	mov esi,Trace[ebx*4]
	and Diss.Flags,0
	mov Diss.Mode,DISASM_MODE_32
	invoke dizahex_disasm, Esi, addr Diss
	.if Eax > MAX_IL
		Int 3
	.endif
	mov Ip,esi
	invoke DiQueryPrefixes, Esi
	mov DiPfx,eax
	
	test Diss.Flags,80000H	; F_PFX_REP
	.if !Zero?
		xor eax,eax
		jmp Exit
	.endif
	
	add esi,eax	; ~opcode

	invoke DiIsLine, Esi
	.if Carry?	; Line
		movzx ecx,Diss.Len
		mov esi,Ip
		rep movsb
		
		.if Tb == Ebx
		
			; * rotate trace: line-line -> line-jcc ?
			
			jmp Jumper
		.endif
	.else
		movzx eax,B[esi]
		
		cmp al,OP_ESC2B
		je OpEsc2b
	
		cmp al,JCC_BASE_SHORT
		jb Skip
		cmp al,JCC_BASE_SHORT + 15
		jna Jcc8

		sub al,0E9H
		je Rjump32
		sub al,2
		je Rjump8
	Skip:
		xor eax,eax
		jmp Exit
	.endif
	%RWALK Ebx
	jmp Walk

Rjump8:
Rjump32:
	.if Tb == Ebx
		mov B[edi],0E9H
		lea eax,Run
		sub eax,edi
		sub eax,5
		mov D[edi][1],eax
		jmp Okey
	.endif
	%RWALK Ebx
	jmp Walk
	
Jcc8:
	movzx edx,B[esi][1]
	sub eax,JCC_BASE_SHORT	; Cc
	btr edx,7
	.if Carry?
		sub edx,80H
	.endif
	lea edx,[edx][esi][2]	; Flow Ip.

Jcc:
	.if Tb == Ebx
		
		add eax,JCC_BASE_NEAR
		mov B[edi][0],OP_ESC2B
		mov D[edi][1],eax
		
		lea eax,Run
		sub eax,edi
		sub eax,6
		mov D[edi][2],eax
		add edi,6

	Jumper:
		movzx eax,Diss.Len
		add eax,Ip
		invoke TcmAdd, Eax
		sub eax,edi
		sub eax,5
		mov B[edi],0E9H
		mov D[edi][1],eax
	Okey:
		mov eax,TRUE
	Exit:
		ret
	.endif
	
	%RWALK Ebx

	.if Trace[Ebx*4] == Edx
		xor eax,1			; ~CC
		
		add eax,JCC_BASE_NEAR
		mov B[edi][0],OP_ESC2B
		mov D[edi][1],eax
		
		movzx eax,Diss.Len
		add eax,Ip	; Ip'
		invoke TcmAdd, Eax
		sub eax,edi
		sub eax,6
		mov D[edi][2],eax
	.else
		add eax,JCC_BASE_NEAR
		mov B[edi][0],OP_ESC2B
		mov D[edi][1],eax
		
		invoke TcmAdd, Edx
		sub eax,edi
		sub eax,6
		mov D[edi][2],eax
	.endif

	add edi,6
	jmp Walk
	
OpEsc2b:
	movzx eax,B[esi][1]
	sub eax,JCC_BASE_NEAR
	jb Skip
	cmp al,16
	jnb Skip
Jcc32:
	mov edx,D[esi][2]
	lea edx,[edx][esi][6]
	jmp Jcc
CyIsolate endp