	.686
	.mmx
	.model flat, stdcall
	option casemap :none
	
	include \masm32\include\ntdll.inc
	includelib \masm32\lib\ntdll.lib
	
	include \masm32\include\kernel32.inc
	includelib \masm32\lib\kernel32.lib

.code
EOL	equ NULL
CRLF	equ <13, 10, EOL>

%DBG macro Msg$, ArgList:VARARG
Local S$
	pushfd
	pushad
	Args = 1
	For Arg, <ArgList>
		Args = Args + 1
		push Arg
	Endm
.data
	S$ CHAR Msg$, CRLF
.code
	push offset S$
	Call DbgPrint
	add esp,Args * 4
	popad
	popfd
endm

%NTERR macro
	.if Eax
	   Int 3
	.endif
endm

%APIERR macro
	.if !Eax
	   Int 3
	.endif
endm

MAX_TRACE	equ 64

TR_FULL	equ 0
TR_TRACK	equ 1

.data
Trace	PVOID MAX_TRACE DUP (?)
Ti		PVOID ?
Tu		ULONG ?
Ta		ULONG ?
Tb		ULONG ?

.code
	include Mm.asm

comment '
 -= Circular(ring) buffer =-
 
Trace:
	...
Ti:
	last
	n+1
	n+2
	
 - overflow -

Trace:
	n+3
	n+4
	...
Ti:
	last
	n+1
	n+2
	'

; * check for end of buffer.
;
%RWALK macro R
	dec R
	.if Sign?
		mov R,MAX_TRACE - 1
	.endif
endm

; +
;
RingAdd proc V:PVOID
	mov eax,Ti
	%RWALK Eax
	mov ecx,V
	mov Trace[eax*4],ecx
	bts Tu,TR_FULL
	mov Ti,eax
	ret
RingAdd endp

; +
;
RingScan proc uses edi V:PVOID
	mov eax,V
	mov ecx,Ti
	lea edi,Trace[ecx*4]
	not ecx
	add ecx,MAX_TRACE + 1
	jecxz @f
	repne scasd
	je Store
@@:
	bt Tu,TR_FULL
	.if Carry?
		mov ecx,Ti
		lea edi,Trace
		jecxz Fail
		repne scasd
		.if Zero?
	Store:
			sub edi,offset Trace + 4
			shr edi,2
			mov eax,edi
			jmp Exit
		.endif
	.endif
Fail:
	xor eax,eax
Exit:
	ret
RingScan endp

; +
;
CyDetect proc uses ebx esi edi Ip:PVOID
	bt Tu,TR_TRACK
	.if !Carry?
		invoke RingScan, Ip
		.if Eax
			mov ecx,Ti
			mov Ta,eax
			mov Ti,eax
			bts Tu,TR_TRACK
			mov Tb,ecx
		.else
			invoke RingAdd, Ip
		.endif
	.else
		%RWALK Ti
		mov eax,Ti
		mov ecx,Trace[eax*4]
		.if Ip == Ecx
			.if Tb == Eax
				btr Tu,TR_TRACK
				and Ti,0
				inc eax
				jmp Exit
			.endif
		.else
			btr Tu,TR_TRACK
			invoke RingAdd, Ip
		.endif
	.endif
	xor eax,eax
Exit:
	ret
CyDetect endp		

	include Diss.asm

%STRACE macro
	push EFLAGS_TF or EFLAGS_MASK
	popfd
endm

Extern _imp__KiUserExceptionDispatcher@8:DWORD

Trap proc uses ebx esi edi ExceptionPointers:PEXCEPTION_POINTERS
	mov eax,ExceptionPointers
	mov ecx,EXCEPTION_POINTERS.ExceptionRecord[eax]
	assume ecx:PEXCEPTION_RECORD
	mov ebx,EXCEPTION_POINTERS.ContextRecord[eax]
	assume ebx:PCONTEXT
	cmp [ecx].ExceptionCode,STATUS_SINGLE_STEP
	jne Chain
	
	mov ecx,D[_imp__KiUserExceptionDispatcher@8]
	mov eax,[ebx].rEip
	lea edx,[ecx + 30]
	.if (Eax >= Ecx) && (Eax < Edx)
		and [ebx].rEFlags,NOT(EFLAGS_TF)
		jmp Load
	.endif
	invoke CyDetect, [Ebx].rEip
	.if Eax
		mov eax,[ebx].rEip
		invoke CyIsolate
		.if Eax
			lea eax,Run
			mov [ebx].rEip,eax
			jmp Load
		.endif
	.endif
	or [ebx].rEFlags,EFLAGS_TF
Load:
	mov eax,EXCEPTION_CONTINUE_EXECUTION
Exit:
	ret
Chain:
	xor eax,eax
	jmp Exit
Trap endp

TestIp proc C
	mov ecx,8
	xor eax,eax
	.repeat
		xor edx,edx
		nop
		jz L1
		inc edx
	L1:
		dec edx
		jnz L2
		nop
	L2:
		mov edx,ecx
		jz L3
		nop
	L3:
		dec ecx
	.until Zero?
	mov eax,edx
	ret
TestIp endp

$Dll	CHAR "ntdll.dll", 0

EP proc uses ebx esi edi

	invoke CmAlloc, addr TcmGet, addr Tcm
	invoke RtlAddVectoredExceptionHandler, 1, addr Trap
	%APIERR
	%STRACE
	nop
	invoke TestIp
	invoke TestIp
;	invoke TestIp
	invoke GetModuleHandle, addr $Dll
	ret
EP endp
end EP